package org.jboss.errai.marshalling.client.api;

import com.kdm.provider.data.SearchResult;
import com.vividsolutions.jts.geom.Geometry;
import java.util.List;
import org.jboss.errai.marshalling.client.Marshalling;
import org.jboss.errai.marshalling.client.api.json.EJObject;
import org.jboss.errai.marshalling.client.api.json.EJValue;

public class Marshaller_for_com_kdm_provider_data_SearchResult_Impl implements GeneratedMarshaller<SearchResult> {
  private SearchResult[] EMPTY_ARRAY = new SearchResult[0];
  private Marshaller<Geometry> com_vividsolutions_jts_geom_Geometry = Marshalling.getMarshaller(Geometry.class);
  private Marshaller<List> java_util_List = Marshalling.getMarshaller(List.class);
  public SearchResult[] getEmptyArray() {
    return EMPTY_ARRAY;
  }

  public SearchResult demarshall(EJValue a0, MarshallingSession a1) {
    lazyInit();
    EJObject obj = a0.isObject();
    if (obj == null) {
      return null;
    }
    String objId = obj.get("^ObjectID").isString().stringValue();
    if (a1.hasObject(objId)) {
      return a1.getObject(SearchResult.class, objId);
    }
    SearchResult entity = new SearchResult();
    a1.recordObject(objId, entity);
    if ((obj.containsKey("geoShape")) && (!obj.get("geoShape").isNull())) {
      entity.setGeoShape(com_vividsolutions_jts_geom_Geometry.demarshall(obj.get("geoShape"), a1));
    }
    entity.facets = java_util_List.demarshall(obj.get("facets"), a1);
    if ((obj.containsKey("details")) && (!obj.get("details").isNull())) {
      a1.setAssumedElementType("com.kdm.provider.data.Detail");
      entity.setDetails(java_util_List.demarshall(obj.get("details"), a1));
    }
    return entity;
  }

  public String marshall(SearchResult a0, MarshallingSession a1) {
    lazyInit();
    if (a0 == null) {
      return "null";
    }
    final boolean ref = a1.hasObject(a0);
    final StringBuilder json = new StringBuilder("{\"^EncodedType\":\"com.kdm.provider.data.SearchResult\",\"^ObjectID\"");
    json.append(":\"").append(a1.getObject(a0)).append("\"");
    if (ref) {
      return json.append("}").toString();
    }
    return json.append(",").append("\"geoShape\":").append(com_vividsolutions_jts_geom_Geometry.marshall(a0.getGeoShape(), a1)).append(",").append("\"facets\":").append(java_util_List.marshall(a0.facets, a1)).append(",").append("\"details\":").append(java_util_List.marshall(a0.getDetails(), a1)).append("}").toString();
  }

  private void lazyInit() {

  }
}